// Code generated by entc, DO NOT EDIT.

package ent

import (
	"context"
	"fmt"

	"github.com/facebook/ent/dialect/sql"
	"github.com/facebook/ent/dialect/sql/sqlgraph"
	"github.com/facebook/ent/schema/field"
	"github.com/kallydev/privacy/ent/predicate"
	"github.com/kallydev/privacy/ent/qqmodel"
)

// QQModelDelete is the builder for deleting a QQModel entity.
type QQModelDelete struct {
	config
	hooks    []Hook
	mutation *QQModelMutation
}

// Where adds a new predicate to the delete builder.
func (qmd *QQModelDelete) Where(ps ...predicate.QQModel) *QQModelDelete {
	qmd.mutation.predicates = append(qmd.mutation.predicates, ps...)
	return qmd
}

// Exec executes the deletion query and returns how many vertices were deleted.
func (qmd *QQModelDelete) Exec(ctx context.Context) (int, error) {
	var (
		err      error
		affected int
	)
	if len(qmd.hooks) == 0 {
		affected, err = qmd.sqlExec(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*QQModelMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			qmd.mutation = mutation
			affected, err = qmd.sqlExec(ctx)
			mutation.done = true
			return affected, err
		})
		for i := len(qmd.hooks) - 1; i >= 0; i-- {
			mut = qmd.hooks[i](mut)
		}
		if _, err := mut.Mutate(ctx, qmd.mutation); err != nil {
			return 0, err
		}
	}
	return affected, err
}

// ExecX is like Exec, but panics if an error occurs.
func (qmd *QQModelDelete) ExecX(ctx context.Context) int {
	n, err := qmd.Exec(ctx)
	if err != nil {
		panic(err)
	}
	return n
}

func (qmd *QQModelDelete) sqlExec(ctx context.Context) (int, error) {
	_spec := &sqlgraph.DeleteSpec{
		Node: &sqlgraph.NodeSpec{
			Table: qqmodel.Table,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: qqmodel.FieldID,
			},
		},
	}
	if ps := qmd.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return sqlgraph.DeleteNodes(ctx, qmd.driver, _spec)
}

// QQModelDeleteOne is the builder for deleting a single QQModel entity.
type QQModelDeleteOne struct {
	qmd *QQModelDelete
}

// Exec executes the deletion query.
func (qmdo *QQModelDeleteOne) Exec(ctx context.Context) error {
	n, err := qmdo.qmd.Exec(ctx)
	switch {
	case err != nil:
		return err
	case n == 0:
		return &NotFoundError{qqmodel.Label}
	default:
		return nil
	}
}

// ExecX is like Exec, but panics if an error occurs.
func (qmdo *QQModelDeleteOne) ExecX(ctx context.Context) {
	qmdo.qmd.ExecX(ctx)
}
